"""
Django settings for recorridolocal project.

Generated by 'django-admin startproject' using Django 3.2.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path
import os

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-9u8k&an3%47bw_o+&7bc6*9281p!rm3by(o!(zn-&x1tgq%l4-'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['*']


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.gis',
    "django.contrib.postgres",
    #"django.contrib.sites",
    'puerto',
    'plataforma',
    #'comunidad',
    #'alojamiento',
    #'tours',
    #'gastronomia',
    #'servicios',
    #'historia',
    'tailwind',
    'theme',
    'django_browser_reload',
    'leaflet',
    'djgeojson',
    'gisserver',
    'giswfs',


]


import ee
#
ee.Initialize()

dataset = (ee.ImageCollection("COPERNICUS/S2_SR")
                  .filter(ee.Filter.date('2021-03-28', '2022-03-19'))
                  .sort('CLOUD_COVER', True)
                  .mosaic()
                  )
                  #.mosaic())
                  #.first())
#modisrgb = dataset.select('TCI_R','TCI_G','TCI_B')
#Styling 
vis_paramsRGB = {
  #"bands": ["TCI_R","TCI_B","TCI_G",]
  "bands": ["B4", "B3", "B2"],
  "gain": '0.08, 0.08, 0.08',
  #"scale": 1
}
#add the map to the the folium map
map_id_dict = dataset.getMapId(vis_paramsRGB)
tile_url = map_id_dict['tile_fetcher'].url_format
#print(tile_url)

LEAFLET_CONFIG = {
    # conf here
    #'SPATIAL_EXTENT': (5.0, -38.7999968, 7.5, -71.2833322),
    'DEFAULT_CENTER': (-38.7999968, -71.2833322),
    'DEFAULT_ZOOM': 13,
    'MIN_ZOOM': 5,
    'MAX_ZOOM': 18,
    'DEFAULT_PRECISION': 6,
    'ATTRIBUTION_PREFIX':'Leaflet - EE Sentinel2 - NestoLab',
    'TILES': tile_url,


}
#LEAFLET_CONFIG = {}

TAILWIND_APP_NAME = 'theme'

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django_browser_reload.middleware.BrowserReloadMiddleware',

]

ROOT_URLCONF = 'rutalocal.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [str(BASE_DIR.joinpath('templates'))],

        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
            # PyPugJS part:
            'loaders': [
                ('pypugjs.ext.django.Loader', (
                    'django.template.loaders.filesystem.Loader',
                    'django.template.loaders.app_directories.Loader',
                ))
            ],
            'builtins': [
                'pypugjs.ext.django.templatetags',
            ],
        },
    },
]


WSGI_APPLICATION = 'rutalocal.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

#DATABASES = {
#    'default': {
#        'ENGINE': 'django.db.backends.sqlite3',
#        'NAME': BASE_DIR / 'db.sqlite3',
#    }
#}

DATABASES = {
    'default': {
        'ENGINE': 'django.contrib.gis.db.backends.postgis',
        'NAME': 'rutalocal',
        'USER': 'postgres',
        'PASSWORD': 'postgres',
        'HOST': 'localhost',
        'PORT': '5432',

    },
}

# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

INTERNAL_IPS = [
    "127.0.0.1",
]

MEDIA_ROOT =  os.path.join(BASE_DIR, 'media')
MEDIA_URL = '/media/'